///Bilgisayar programlama II ve Sayısal Çözümleme
// 
//  
// Sekant yöntemi ile kök bulmak 
//  
//  

import java.util.*;
import java.awt.*;
import java.applet.Applet;
import java.awt.event.*;
import javax.swing.*;

//============= Tanımı gereken fonksiyon ================

class fb extends f_x
{
   public double func (double x)
   { return x*x*x-5*x*x+7*x-3;}
}
public class FSCO4
{
public static double sekant(f_x f,double x)
{
int nmax=100;
double tolerance=1.0e-10;
double fx,dfx;
double dx=0.01;
for(int i=0;i<nmax;i++)
{
  fx=f.func(x);
  dfx=(f.func(x+dx)-f.func(x-dx))/(2.0*dx);
  x-=fx/dfx;
  if(Math.abs(fx)<tolerance) { return x;}
}
JOptionPane.showMessageDialog(null,"Uyarı maximum iterasyon sayısı aşıldı \n"+
   " çözüm geçerli olmıyabilir","MAKSİMUM ITERASYON SAYISI UYARISI",JOptionPane.WARNING_MESSAGE);
return x;
}

     public static void main (String args[])  
     {
	 fb f=new fb();
     double x0;
     x0=Double.parseDouble(JOptionPane.showInputDialog(" Fonksiyon değeri için ilk tahmin : "));
     double r= sekant(f,x0);
     JOptionPane.showMessageDialog(null," kök değeri  : "+r+"\nFonksiyon değeri : "+f.func(r),
     "Sekant yöntemiyle kök hesabı : ",JOptionPane.PLAIN_MESSAGE);
     System.exit(0);
     } 
}